Index: src/language/stats/aggregate.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/aggregate.c,v
retrieving revision 1.12
diff -U3 -r1.12 aggregate.c
--- src/language/stats/aggregate.c	27 Jun 2006 19:09:22 -0000	1.12
+++ src/language/stats/aggregate.c	4 Jul 2006 06:05:08 -0000
@@ -18,7 +18,7 @@
    02110-1301, USA. */
 
 #include <config.h>
-
+#include <libpspp/Assert.h>
 #include <stdlib.h>
 
 #include <data/any-writer.h>
@@ -571,7 +571,7 @@
 		  destvar = dict_clone_var (agr->dict, v->src, dest[i]);
 		else
                   {
-                    assert (v->src->type == NUMERIC
+                    Assert (v->src->type == NUMERIC
                             || function->alpha_type == NUMERIC);
                     destvar = dict_create_var (agr->dict, dest[i], 0);
                     if (destvar != NULL) 
@@ -892,7 +892,7 @@
                caught earlier.  Nothing to do. */
             break;
 	  default:
-	    assert (0);
+	    AssertNotReached ();
 	  }
     } else {
       switch (iter->function)
@@ -904,7 +904,7 @@
 	  iter->int1++;
 	  break;
 	default:
-	  assert (0);
+	  AssertNotReached ();
 	}
     }
 }
@@ -1033,7 +1033,7 @@
 	    v->f = i->int1;
 	    break;
 	  default:
-	    assert (0);
+	    AssertNotReached ();
 	  }
       }
   }
Index: src/language/stats/crosstabs.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/crosstabs.q,v
retrieving revision 1.11
diff -U3 -r1.11 crosstabs.q
--- src/language/stats/crosstabs.q	28 Jun 2006 02:21:28 -0000	1.11
+++ src/language/stats/crosstabs.q	4 Jul 2006 06:05:09 -0000
@@ -127,8 +127,8 @@
 static inline struct var_range *
 get_var_range (struct variable *v) 
 {
-  assert (v != NULL);
-  assert (v->aux != NULL);
+  Assert (v != NULL);
+  Assert (v->aux != NULL);
   return v->aux;
 }
 
@@ -321,7 +321,7 @@
     var_set = var_set_create_from_array (variables, variables_cnt);
   else
     var_set = var_set_create_from_dict (default_dict);
-  assert (var_set != NULL);
+  Assert (var_set != NULL);
   
   for (n_by = 0; ;)
     {
@@ -583,7 +583,7 @@
       {
 	int j;
 
-	assert (x != NULL);
+	Assert (x != NULL);
 	for (j = 0; j < x->nvar; j++)
 	  {
             const union value *v = case_data (c, x->vars[j]->fv);
@@ -720,7 +720,7 @@
 	}
       else 
 	{
-	  assert (x->vars[i]->type == ALPHA);
+	  Assert (x->vars[i]->type == ALPHA);
 	  {
 	    const int diffstr = strncmp (a->values[i].s, b->values[i].s,
                                          x->vars[i]->width);
@@ -1084,7 +1084,7 @@
 	    const struct tuple *t;
 
 	    for (t = cell_names; t->value != cells[i]; t++)
-	      assert (t->value != -1);
+	      Assert (t->value != -1);
 	    if (i)
 	      cp = stpcpy (cp, ", ");
 	    cp = stpcpy (cp, gettext (t->name));
@@ -1295,7 +1295,7 @@
 	  int r, c;
 	  double *tp = col_tot;
 	  
-	  assert (mode == INTEGER);
+	  Assert (mode == INTEGER);
 	  mat = (*tb)->u.data;
 	  ns_cols = n_cols;
 
@@ -1359,7 +1359,7 @@
 	if (tb != pb)
 	  for (; ; first_difference--)
 	    {
-	      assert (first_difference >= 2);
+	      Assert (first_difference >= 2);
 	      if (memcmp (&cmp->values[first_difference],
 			  &(*tb)->values[first_difference],
                           sizeof *cmp->values))
@@ -1553,7 +1553,7 @@
       tp++;
       if (--*cnt == 0)
 	break;
-      assert (*cnt > 0);
+      Assert (*cnt > 0);
 
       if ((*tp)->table != fp->table)
 	break;
@@ -1587,7 +1587,7 @@
       tp++;
       if (--*cnt == 0)
 	break;
-      assert (*cnt > 0);
+      Assert (*cnt > 0);
 
       if ((*tp)->table != fp->table)
 	break;
@@ -1647,7 +1647,7 @@
       struct var_range *vr = get_var_range (v);
       int i;
       
-      assert (mode == INTEGER);
+      Assert (mode == INTEGER);
       *values = xnmalloc (vr->count, sizeof **values);
       for (i = 0; i < vr->count; i++)
 	(*values)[i].f = i + vr->min;
@@ -1799,8 +1799,7 @@
 				 * (1. - col_tot[c] / W)));
 		    break;
 		  default:
-		    assert (0);
-                    abort ();
+		    AssertNotReached ();
 		  }
 
                 format_cell_entry (table, c, i, v, suffix, mark_missing);
@@ -1855,8 +1854,7 @@
                 v = 0.;
                 break;
               default:
-                assert (0);
-                abort ();
+                AssertNotReached ();
               }
 
             format_cell_entry (table, n_cols, 0, v, suffix, mark_missing);
@@ -1911,8 +1909,7 @@
 	      case CRS_CL_ASRESIDUAL:
 		continue;
 	      default:
-		assert (0);
-                abort ();
+		AssertNotReached ();
 	      }
 
             format_cell_entry (table, c, i, v, suffix, mark_missing);
@@ -2353,7 +2350,7 @@
 		break;
 	    }
 
-	assert (j == 2);
+	Assert (j == 2);
 
 	f11 = mat[nz_cols[0]];
 	f12 = mat[nz_cols[1]];
@@ -2566,7 +2563,7 @@
 		
 		if (++j == n_cols)
 		  break;
-		assert (j < n_cols);
+		Assert (j < n_cols);
 
 		Cij -= col_tot[j] - cum[j + i * n_cols];
 		Dij += col_tot[j - 1] - cum[j - 1 + i * n_cols];
@@ -2638,7 +2635,7 @@
 		
 		if (++j == n_cols)
 		  break;
-		assert (j < n_cols);
+		Assert (j < n_cols);
 
 		Cij -= col_tot[j] - cum[j + i * n_cols];
 		Dij += col_tot[j - 1] - cum[j - 1 + i * n_cols];
@@ -2714,7 +2711,7 @@
 	    s = t;
 	    if (++i == n_rows)
 	      break;
-	    assert (i < n_rows);
+	    Assert (i < n_rows);
 	  }
       }
       
@@ -2731,7 +2728,7 @@
 	    s = t;
 	    if (++j == n_cols)
 	      break;
-	    assert (j < n_cols);
+	    Assert (j < n_cols);
 	  }
       }
       
@@ -2828,7 +2825,7 @@
 	    break;
 	}
 
-    assert (j == 2);
+    Assert (j == 2);
 
     f11 = mat[nz_cols[0]];
     f12 = mat[nz_cols[1]];
@@ -3189,7 +3186,7 @@
     {
       fmt_subst = *fp;
 
-      assert (fmt_subst.type == FMT_A || fmt_subst.type == FMT_AHEX);
+      Assert (fmt_subst.type == FMT_A || fmt_subst.type == FMT_AHEX);
       if (fmt_subst.type == FMT_A)
         fmt_subst.w = min (8, fmt_subst.w);
       else
Index: src/language/stats/descriptives.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/descriptives.c,v
retrieving revision 1.9
diff -U3 -r1.9 descriptives.c
--- src/language/stats/descriptives.c	27 Jun 2006 19:09:22 -0000	1.9
+++ src/language/stats/descriptives.c	4 Jul 2006 06:05:09 -0000
@@ -20,6 +20,7 @@
 /* FIXME: Many possible optimizations. */
 
 #include <config.h>
+#include <libpspp/Assert.h>
 
 #include <limits.h>
 #include <math.h>
@@ -585,7 +586,7 @@
 
   if (t->missing_type == DSC_LISTWISE)
     {
-      assert(t->vars);
+      Assert (t->vars);
       for (vars = t->vars; vars < t->vars + t->var_cnt; vars++)
 	{
 	  double score = case_num (c, (*vars)->fv);
@@ -622,7 +623,7 @@
   struct dsc_trns *t = trns_;
 
   free (t->z_scores);
-  assert((t->missing_type != DSC_LISTWISE) ^ (t->vars != NULL));
+  Assert ((t->missing_type != DSC_LISTWISE) ^ (t->vars != NULL));
   free (t->vars);
   return true;
 }
Index: src/language/stats/examine.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/examine.q,v
retrieving revision 1.8
diff -U3 -r1.8 examine.q
--- src/language/stats/examine.q	28 Jun 2006 02:21:28 -0000	1.8
+++ src/language/stats/examine.q	4 Jul 2006 06:05:09 -0000
@@ -523,7 +523,7 @@
       return 0;
     }
 
-  assert(n_dependent_vars);
+  Assert (n_dependent_vars);
 
   totals = xnmalloc (n_dependent_vars, sizeof *totals);
 
@@ -640,7 +640,7 @@
       else
 	indep_vals[1].f = SYSMIS;
 
-      assert(fctr->fstats);
+      Assert (fctr->fstats);
 
       foo = ( struct factor_statistics ** ) 
 	hsh_probe(fctr->fstats, (void *) &indep_vals);
@@ -1548,7 +1548,7 @@
     
     p = hsh_find(m->ptile_hash, &d);
     
-    assert(p);
+    Assert (p);
 
 
     tab_float (tbl, col + 2, 
@@ -1634,8 +1634,8 @@
     d = 25;
     p2 = hsh_find(m->ptile_hash, &d);
 
-    assert(p1);
-    assert(p2);
+    Assert (p1);
+    Assert (p2);
 
     tab_float (tbl, col + 2, 
 	       row + 10,
Index: src/language/stats/flip.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/flip.c,v
retrieving revision 1.10
diff -U3 -r1.10 flip.c
--- src/language/stats/flip.c	27 Jun 2006 19:09:22 -0000	1.10
+++ src/language/stats/flip.c	4 Jul 2006 06:05:09 -0000
@@ -17,7 +17,8 @@
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
    02110-1301, USA. */
 
-#include "config.h"
+#include <config.h>
+#include <libpspp/Assert.h>
 
 #include <ctype.h>
 #include <errno.h>
@@ -538,7 +539,7 @@
           else if (feof (flip->file))
             msg (SE, _("Unexpected end of file reading FLIP temporary file."));
           else
-            abort ();
+            AssertNotReached ();
           ok = false;
           break;
         }
Index: src/language/stats/frequencies.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/frequencies.q,v
retrieving revision 1.11
diff -U3 -r1.11 frequencies.q
--- src/language/stats/frequencies.q	28 Jun 2006 02:21:28 -0000	1.11
+++ src/language/stats/frequencies.q	4 Jul 2006 06:05:09 -0000
@@ -269,8 +269,8 @@
 static inline struct var_freqs *
 get_var_freqs (struct variable *v)
 {
-  assert (v != NULL);
-  assert (v->aux != NULL);
+  Assert (v != NULL);
+  Assert (v->aux != NULL);
   return v->aux;
 }
 
@@ -557,7 +557,7 @@
 	    ft->out_of_range += weight;
 	  break;
 	default:
-	  assert (0);
+	  AssertNotReached ();
 	}
     }
   return true;
@@ -645,7 +645,7 @@
 	      dump_full (v);
 	    break;
 	  default:
-	    assert (0);
+	    AssertNotReached ();
 	  }
       else
 	dumped_freq_tab = 0;
@@ -706,7 +706,7 @@
     case FRQ_AFREQ | (ALPHA << 16):     return compare_freq_alpha_a;
     case FRQ_DFREQ | (NUMERIC << 16):   return compare_freq_numeric_d;
     case FRQ_DFREQ | (ALPHA << 16):     return compare_freq_alpha_d;
-    default: assert (0);
+    default: AssertNotReached ();
     }
 
   return 0;
@@ -735,7 +735,7 @@
   size_t i;
 
   ft = &get_var_freqs (v)->tab;
-  assert (ft->mode == FRQM_GENERAL);
+  Assert (ft->mode == FRQM_GENERAL);
   compare = get_freq_comparator (cmd.sort, v->type);
 
   /* Extract data from hash table. */
@@ -783,7 +783,7 @@
 cleanup_freq_tab (struct variable *v)
 {
   struct freq_tab *ft = &get_var_freqs (v)->tab;
-  assert (ft->mode == FRQM_GENERAL);
+  Assert (ft->mode == FRQM_GENERAL);
   free (ft->valid);
   hsh_destroy (ft->data);
 }
Index: src/language/stats/means.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/means.q,v
retrieving revision 1.6
diff -U3 -r1.6 means.q
--- src/language/stats/means.q	28 Jun 2006 02:21:28 -0000	1.6
+++ src/language/stats/means.q	4 Jul 2006 06:05:09 -0000
@@ -141,7 +141,7 @@
     }
 
   var_set = var_set_create_from_dict (default_dict);
-  assert (var_set != NULL);
+  Assert (var_set != NULL);
 
   do
     {
Index: src/language/stats/oneway.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/oneway.q,v
retrieving revision 1.8
diff -U3 -r1.8 oneway.q
--- src/language/stats/oneway.q	28 Jun 2006 02:21:28 -0000	1.8
+++ src/language/stats/oneway.q	4 Jul 2006 06:05:09 -0000
@@ -241,7 +241,7 @@
       return 0;
     }
 
-  assert(n_vars);
+  Assert(n_vars);
 
   if ( ! lex_match(T_BY))
     return 2;
Index: src/language/stats/rank.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/rank.q,v
retrieving revision 1.9
diff -U3 -r1.9 rank.q
--- src/language/stats/rank.q	28 Jun 2006 02:21:28 -0000	1.9
+++ src/language/stats/rank.q	4 Jul 2006 06:05:09 -0000
@@ -19,6 +19,7 @@
 02110-1301, USA. */
 
 #include <config.h>
+#include <libpspp/Assert.h>
 
 #include "sort-criteria.h"
 
@@ -206,7 +207,7 @@
 	  break;
 
 	default:
-	  assert(false);
+	  AssertNotReached ();
 	  break;
 	}
   
Index: src/language/stats/regression.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/regression.q,v
retrieving revision 1.27
diff -U3 -r1.27 regression.q
--- src/language/stats/regression.q	28 Jun 2006 02:21:28 -0000	1.27
+++ src/language/stats/regression.q	4 Jul 2006 06:05:10 -0000
@@ -151,7 +151,7 @@
   double adjrsq;
   double std_error;
 
-  assert (c != NULL);
+  Assert (c != NULL);
   rsq = c->ssm / c->sst;
   adjrsq = 1.0 - (1.0 - rsq) * (c->n_obs - 1.0) / (c->n_obs - c->n_indeps);
   std_error = sqrt ((c->n_indeps - 1.0) / (c->n_obs - 1.0));
@@ -195,7 +195,7 @@
   const char *val_s;
   struct tab_table *t;
 
-  assert (c != NULL);
+  Assert (c != NULL);
   tmp = xnmalloc (MAX_STRING, sizeof (*tmp));
   n_rows = c->n_coeffs + 2;
 
@@ -292,7 +292,7 @@
 
   struct tab_table *t;
 
-  assert (c != NULL);
+  Assert (c != NULL);
   t = tab_create (n_cols, n_rows, 0);
   tab_headers (t, 2, 0, 1, 0);
   tab_dim (t, tab_natural_dimensions);
@@ -339,32 +339,32 @@
 static void
 reg_stats_outs (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 static void
 reg_stats_zpp (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 static void
 reg_stats_label (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 static void
 reg_stats_sha (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 static void
 reg_stats_ci (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 static void
 reg_stats_f (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 static void
 reg_stats_bcov (pspp_linreg_cache * c)
@@ -378,7 +378,7 @@
   const char *label;
   struct tab_table *t;
 
-  assert (c != NULL);
+  Assert (c != NULL);
   n_cols = c->n_indeps + 1 + 2;
   n_rows = 2 * (c->n_indeps + 1);
   t = tab_create (n_cols, n_rows, 0);
@@ -410,27 +410,27 @@
 static void
 reg_stats_ses (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 static void
 reg_stats_xtx (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 static void
 reg_stats_collin (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 static void
 reg_stats_tol (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 static void
 reg_stats_selection (pspp_linreg_cache * c)
 {
-  assert (c != NULL);
+  Assert (c != NULL);
 }
 
 static void
@@ -554,18 +554,18 @@
   const union value **vals = NULL;
   struct variable **vars = NULL;
 
-  assert (trns != NULL);
+  Assert (trns != NULL);
   model = trns->c;
-  assert (model != NULL);
-  assert (model->depvar != NULL);
-  assert (model->pred != NULL);
+  Assert (model != NULL);
+  Assert (model->depvar != NULL);
+  Assert (model->pred != NULL);
 
   vars = xnmalloc (model->n_coeffs, sizeof (*vars));
   n_vals = (*model->get_vars) (model, vars);
 
   vals = xnmalloc (n_vals, sizeof (*vals));
   output = case_data_rw (c, model->pred->fv);
-  assert (output != NULL);
+  Assert (output != NULL);
 
   for (i = 0; i < n_vals; i++)
     {
@@ -593,18 +593,18 @@
   const union value *obs = NULL;
   struct variable **vars = NULL;
 
-  assert (trns != NULL);
+  Assert (trns != NULL);
   model = trns->c;
-  assert (model != NULL);
-  assert (model->depvar != NULL);
-  assert (model->resid != NULL);
+  Assert (model != NULL);
+  Assert (model->depvar != NULL);
+  Assert (model->resid != NULL);
 
   vars = xnmalloc (model->n_coeffs, sizeof (*vars));
   n_vals = (*model->get_vars) (model, vars);
 
   vals = xnmalloc (n_vals, sizeof (*vals));
   output = case_data_rw (c, model->resid->fv);
-  assert (output != NULL);
+  Assert (output != NULL);
 
   for (i = 0; i < n_vals; i++)
     {
@@ -656,7 +656,7 @@
   t->c = c;
   reg_get_name (name, prefix);
   new_var = dict_create_var (default_dict, name, 0);
-  assert (new_var != NULL);
+  Assert (new_var != NULL);
   *v = new_var;
   add_transformation (f, regression_trns_free, t);
   trns_index++;
@@ -668,7 +668,7 @@
   int n_trns = 0;
   int i;
 
-  assert (models != NULL);
+  Assert (models != NULL);
 
   if (save)
     {
@@ -684,8 +684,8 @@
 
       for (lc = models; lc < models + cmd.n_dependent; lc++)
 	{
-	  assert (*lc != NULL);
-	  assert ((*lc)->depvar != NULL);
+	  Assert (*lc != NULL);
+	  Assert ((*lc)->depvar != NULL);
 	  if (cmd.a_save[REGRESSION_SV_RESID])
 	    {
 	      reg_save_var ("RES", regression_trns_resid_proc, *lc,
@@ -702,7 +702,7 @@
     {
       for (lc = models; lc < models + cmd.n_dependent; lc++)
 	{
-	  assert (*lc != NULL);
+	  Assert (*lc != NULL);
 	  pspp_linreg_cache_free (*lc);
 	}
     }
@@ -836,10 +836,10 @@
 
   if (export)
     {
-      assert (c != NULL);
-      assert (model_file != NULL);
+      Assert (c != NULL);
+      Assert (model_file != NULL);
       fp = fopen (fh_get_file_name (model_file), "w");
-      assert (fp != NULL);
+      Assert (fp != NULL);
       fprintf (fp, "%s", reg_preamble);
       reg_print_getvar (fp, c);
       if (reg_has_categorical (c))
@@ -1012,7 +1012,7 @@
       free (v_variables);
       return 0;
     }
-  assert (n_variables);
+  Assert (n_variables);
 
   return 1;
 }
@@ -1053,7 +1053,7 @@
   int i;
   int j;
 
-  assert (indep_vars != NULL);
+  Assert (indep_vars != NULL);
   j = 0;
   for (i = 0; i < n_variables; i++)
     {
@@ -1103,7 +1103,7 @@
 
   pspp_linreg_opts lopts;
 
-  assert (models != NULL);
+  Assert (models != NULL);
 
   output_split_file_values (first);
 
@@ -1134,7 +1134,7 @@
       n_indep = get_n_indep ((const struct variable *) cmd.v_dependent[k]);
       lopts.get_indep_mean_std = xnmalloc (n_indep, sizeof (int));
       indep_vars = xnmalloc (n_indep, sizeof *indep_vars);
-      assert (indep_vars != NULL);
+      Assert (indep_vars != NULL);
 
       for (i = 0; i < n_cases; i++)
 	{
Index: src/language/stats/sort-cases.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/sort-cases.c,v
retrieving revision 1.4
diff -U3 -r1.4 sort-cases.c
--- src/language/stats/sort-cases.c	5 May 2006 04:53:13 -0000	1.4
+++ src/language/stats/sort-cases.c	4 Jul 2006 06:05:10 -0000
@@ -19,7 +19,7 @@
 
 #include <config.h>
 
-#include <assert.h>
+#include <libpspp/Assert.h>
 #include <stdlib.h>
 #include <limits.h>
 
Index: src/language/stats/sort-criteria.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/sort-criteria.c,v
retrieving revision 1.3
diff -U3 -r1.3 sort-criteria.c
--- src/language/stats/sort-criteria.c	27 Jun 2006 19:09:22 -0000	1.3
+++ src/language/stats/sort-criteria.c	4 Jul 2006 06:05:10 -0000
@@ -19,7 +19,7 @@
 
 #include <config.h>
 #include <sys/types.h>
-#include <assert.h>
+#include <libpspp/Assert.h>
 #include <stdlib.h>
 #include <limits.h>
 #include <libpspp/alloc.h>
@@ -60,7 +60,7 @@
   struct variable **local_vars = NULL;
   size_t local_var_cnt;
 
-  assert ((vars == NULL) == (var_cnt == NULL));
+  Assert ((vars == NULL) == (var_cnt == NULL));
   if (vars == NULL) 
     {
       vars = &local_vars;
Index: src/language/stats/t-test.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/t-test.q,v
retrieving revision 1.8
diff -U3 -r1.8 t-test.q
--- src/language/stats/t-test.q	28 Jun 2006 02:21:28 -0000	1.8
+++ src/language/stats/t-test.q	4 Jul 2006 06:05:10 -0000
@@ -314,7 +314,7 @@
 	      hsh_insert(hash,pairs[i].v[1]);
 	    }
 
-	  assert(cmd.n_variables == 0);
+	  Assert(cmd.n_variables == 0);
 	  cmd.n_variables = hsh_count(hash);
 
 	  cmd.v_variables = xnrealloc (cmd.v_variables, cmd.n_variables,
@@ -464,7 +464,7 @@
       free (vars);
       return 0;
     }
-  assert (n_vars);
+  Assert (n_vars);
 
   n_before_WITH = 0;
   if (lex_match (T_WITH))
@@ -523,7 +523,7 @@
     {
       int i;
 
-      assert(n_pairs_local == n_vars / 2);
+      Assert(n_pairs_local == n_vars / 2);
       for (i = 0; i < n_pairs_local; ++i)
 	{
 	  pairs[i].v[n_pairs] = vars[i];
@@ -623,7 +623,7 @@
 	ssbox_paired_init(ssb,cmd);
 	break;
       default:
-	assert(0);
+	AssertNotReached ();
       }
 }
 
@@ -751,7 +751,7 @@
       indep_value[1] = gp.v.g_value[1].f;
     }
 
-  assert(ssb->t);
+  Assert(ssb->t);
 
   for (i=0; i < cmd->n_variables; ++i)
     {
@@ -803,7 +803,7 @@
 	    }
 
 	  gs = hsh_find(grp_hash, (void *) &search_val);
-	  assert(gs);
+	  Assert(gs);
 
 	  tab_float(ssb->t, 2 ,i*2+count+1, TAB_RIGHT, gs->n, 2, 0);
 	  tab_float(ssb->t, 3 ,i*2+count+1, TAB_RIGHT, gs->mean, 8, 2);
@@ -844,7 +844,7 @@
 {
   int i;
 
-  assert(ssb->t);
+  Assert(ssb->t);
 
   for (i=0; i < n_pairs; ++i)
     {
@@ -878,7 +878,7 @@
 {
   int i;
 
-  assert(ssb->t);
+  Assert(ssb->t);
 
   for (i=0; i < cmd->n_variables; ++i)
     {
@@ -937,7 +937,7 @@
 	trbox_paired_init(trb,cmd);
 	break;
       default:
-	assert(0);
+	AssertNotReached ();
       }
 }
 
@@ -963,7 +963,7 @@
   const int hsize=11;
   const int vsize=cmd->n_variables*2+3;
 
-  assert(self);
+  Assert(self);
   self->populate = trbox_independent_samples_populate;
 
   trbox_base_init(self,cmd->n_variables*2,hsize);
@@ -1002,7 +1002,7 @@
 {
   int i;
 
-  assert(self);
+  Assert(self);
   for (i=0; i < cmd->n_variables; ++i)
     {
       double p,q;
@@ -1032,7 +1032,7 @@
 	search_val = gp.v.g_value[0];
 
       gs0 = hsh_find(grp_hash, (void *) &search_val);
-      assert(gs0);
+      Assert(gs0);
 
       if ( gp.criterion == CMP_LE ) 
 	search_val.f = gp.v.critical_value + 1.0;
@@ -1040,7 +1040,7 @@
 	search_val = gp.v.g_value[1];
 
       gs1 = hsh_find(grp_hash, (void *) &search_val);
-      assert(gs1);
+      Assert(gs1);
 
 	  
       tab_text (self->t, 0, i*2+3, TAB_LEFT, cmd->v_variables[i]->name);
@@ -1281,7 +1281,7 @@
 {
   int i;
 
-  assert(trb->t);
+  Assert(trb->t);
 
   for (i=0; i < cmd->n_variables; ++i)
     {
@@ -1830,7 +1830,7 @@
 	  gs->se_mean = gs->std_dev / sqrt(gs->n);
 	  count ++;
 	}
-      assert(count == 2);
+      Assert(count == 2);
     }
 }
 
@@ -1933,7 +1933,7 @@
     {
       /* less-than-or-equal comparision is not meaningfull for
 	 alpha variables, so we shouldn't ever arrive here */
-      assert(p->indep_width == 0 ) ;
+      Assert(p->indep_width == 0 ) ;
       
       flag_a = ( a->id.f < p->v.critical_value ) ;
       flag_b = ( b->id.f < p->v.critical_value ) ;
@@ -1962,7 +1962,7 @@
   if ( p->criterion == CMP_LE ) 
     {
       /* Not meaningfull to do a less than compare for alpha values ? */
-      assert(p->indep_width == 0 ) ;
+      Assert(p->indep_width == 0 ) ;
       flag = ( g->id.f < p->v.critical_value ) ; 
     }
   else if ( p->criterion == CMP_EQ) 
@@ -1970,7 +1970,7 @@
       flag = which_group(g,p);
     }
   else
-    assert(0);
+    AssertNotReached ();
 
   return flag;
 }
Index: src/language/utilities/set.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/utilities/set.q,v
retrieving revision 1.9
diff -U3 -r1.9 set.q
--- src/language/utilities/set.q	28 Jun 2006 02:21:28 -0000	1.9
+++ src/language/utilities/set.q	4 Jul 2006 06:05:10 -0000
@@ -52,6 +52,8 @@
 #include "gettext.h"
 #define _(msgid) gettext (msgid)
 
+/* (headers) */
+
 /* (specification)
    "SET" (stc_):
      blanks=custom;
Index: src/language/xforms/recode.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/xforms/recode.c,v
retrieving revision 1.8
diff -U3 -r1.8 recode.c
--- src/language/xforms/recode.c	27 Jun 2006 19:09:22 -0000	1.8
+++ src/language/xforms/recode.c	4 Jul 2006 06:05:10 -0000
@@ -18,6 +18,7 @@
    02110-1301, USA. */
 
 #include <config.h>
+#include <libpspp/Assert.h>
 
 #include <ctype.h>
 #include <math.h>
@@ -526,7 +527,7 @@
       *var = dict_lookup_var (default_dict, name);
       if (*var == NULL)
         *var = dict_create_var_assert (default_dict, name, 0);
-      assert ((*var)->type == trns->dst_type);
+      Assert ((*var)->type == trns->dst_type);
     }
 }
 
@@ -560,7 +561,7 @@
           match = true;
           break;
         default:
-          abort ();
+          AssertNotReached ();
         }
 
       if (match)
@@ -609,7 +610,7 @@
             break;
           }
         default:
-          abort ();
+          AssertNotReached ();
         }
 
       if (match)
Index: src/libpspp/Assert.h
===================================================================
RCS file: src/libpspp/Assert.h
diff -N src/libpspp/Assert.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/libpspp/Assert.h	4 Jul 2006 06:05:10 -0000
@@ -0,0 +1,75 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 2006 Free Software Foundation, Inc.
+   Written by John  Darrington <john@darrington.wattle.id.au>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#ifndef __PSPP_ASSERT_H
+#define __PSPP_ASSERT_H
+
+
+#include <config.h>
+#include <stdbool.h>
+#include <stdio.h>
+#include "message.h"
+#include "compiler.h"
+
+#undef __STRING
+#define __STRING(x) #x
+
+static inline void pspp_not_reached (const char *file, int line) NO_RETURN ;
+
+static inline void 
+pspp_not_reached (const char *file, int line) 
+{
+  char msg[256];
+  snprintf (msg, 256, "%s:%d should not be reached", file, line);
+  request_bug_report_and_abort (msg);
+}
+
+static inline void 
+pspp_assert (const char *expr, const char *file, int line, bool expr_val)
+{
+  if ( ! expr_val ) 
+    {
+      char msg[256];
+      snprintf (msg, 256, "Assertion failed: %s:%d; (%s)", file, line, expr);
+      request_bug_report_and_abort (msg);
+    }
+}
+
+#define AssertLevel 2
+
+#define Assert(expr) ((void) (0))
+#define ExpensiveAssert(expr) ((void) (0))
+#define AssertNotReached() abort()
+
+
+#if AssertLevel > 0
+#  undef Assert
+#  define Assert(expr) pspp_assert(__STRING(expr), __FILE__, __LINE__, expr)
+#  undef AssertNotReached
+#  define AssertNotReached() pspp_not_reached(__FILE__, __LINE__)
+#endif
+
+#if AssertLevel >= 5
+#  undef ExpensiveAssert
+#  define ExpensiveAssert(expr) \
+	pspp_assert(__STRING(expr), __FILE__, __LINE__, expr)
+#endif
+
+
+#endif 
